﻿<?php
/**
 * @version     $Id$ 2.0.1 0
 * @package     Joomla
 * @copyright   Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license     GNU/GPL, see LICENSE.php
 *
 * added/fixed in version 2.0.1
 * - added custom field date format
 * - added mark_required_fields character
 * - added always_send_to_defaut
 * - modified version number
 * - added default profile
 * - removed the fields moved from control panel to profile
 * - added profile_id in contactinformatiosn table
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// function called when the component is installed
function com_install() {
	$_version = '2.0.1.stable';

	// initialize the database
	$db = &JFactory::getDBO();

// 2.0.1 modifications in database 
	// add the field profile_id into contactinformations table
	$query = 'ALTER TABLE `#__aicontactsafe_contactinformations` ADD `profile_id` INT( 11 ) NOT NULL AFTER `id` ;';
	$db->setQuery( $query );
	$db->query();
	
	$query = 'ALTER TABLE `#__aicontactsafe_fields` ADD `label_parameters` TEXT NOT NULL COMMENT \'the parameters of the html label tag\' AFTER `field_label` ;';
	$db->setQuery( $query );
	$db->query();
	
	$query = 'ALTER TABLE `#__aicontactsafe_fields` ADD `field_label_message` varchar(150) NOT NULL default \'\' COMMENT \'the label of the field in the message\' ;';
	$db->setQuery( $query );
	$db->query();

	$query = 'ALTER TABLE `#__aicontactsafe_fields` ADD `label_message_parameters` TEXT NOT NULL COMMENT \'the parameters of the html label in the message tag\' ;';
	$db->setQuery( $query );
	$db->query();

	$query = 'ALTER TABLE `#__aicontactsafe_fields` ADD `field_in_message` tinyint(1) unsigned NOT NULL default \'1\' COMMENT \'1 - field is added in the message, 0 - field is not added in the message\' ;';
	$db->setQuery( $query );
	$db->query();

	$query = 'ALTER TABLE `#__aicontactsafe_fields` ADD `default_value` varchar(150) NOT NULL default \'\' COMMENT \'the default value of the field\' ;';
	$db->setQuery( $query );
	$db->query();
	
	// remove spaces in the field name
	$query = 'UPDATE `#__aicontactsafe_fields` SET name = replace(name,\'\',\'_\') ;';
	$db->setQuery( $query );
	$db->query();

	// use_css_backend
	$key = 'use_css_backend';
	$value = '1';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// activate_help
	$key = 'activate_help';
	$value = '1';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// date_format
	$key = 'date_format';
	$value = '%d %B %Y %H:%M';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// activate_spam_control
	$key = 'activate_spam_control';
	$value = '0';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// block_words
	$key = 'block_words';
	$value = 'url=';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// record_blocked_messages
	$key = 'record_blocked_messages';
	$value = '1';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// activate_ip_ban
	$key = 'activate_ip_ban';
	$value = '0';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// ban_ips
	$key = 'ban_ips';
	$value = '';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// redirect_ips
	$key = 'redirect_ips';
	$value = '';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// upload_attachments
	$key = 'upload_attachments';
	$value = 'components'.DS.'com_aicontactsafe'.DS.'attachments';
	$value = str_replace('\\','&#92;',$value);
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// maximum_size
	$key = 'maximum_size';
	$value = '5000000';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// attachments_types
	$key = 'attachments_types';
	$value = 'rar,zip,doc,xls,txt,gif,jpg,png,bmp';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// attach_to_email
	$key = 'attach_to_email';
	$value = '1';
	$query = 'SELECT id FROM #__aicontactsafe_config WHERE config_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_config` (`id`, `config_key`, `config_value`) VALUES ( null, \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}


	// add default profile
	$query = 'SELECT id FROM #__aicontactsafe_profiles WHERE set_default = 1';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_profiles` (`id`, `name`, `use_message_css`, `use_profile_css`, `use_captcha`, `email_address`, `always_send_to_email_address`, `subject_prefix`, `record_message`, `custom_date_format`, `custom_date_years_back`, `custom_date_years_forward`, `required_field_mark`, `display_format`, `set_default`, `active_fields`, `captcha_width`, `captcha_height`, `captcha_bgcolor`, `captcha_colors`, `date_added`, `last_update`, `published`, `checked_out`, `checked_out_time`) VALUES (1, \'Default form\', 1, 0, 1, \'\', 1, \'\', 1, \'%d %B %Y\', 60, 0, \'( ! )\', 2, 1, \'0\', 400, 55, \'#FFFFFF\', \'#FF0000;#00FF00;#0000FF\', \'2009-01-01 00:00:00\', \'2009-01-01 00:00:00\', 1, 0, \'0000-00-00\');';
		$db->setQuery( $query );
		$db->query();
	}

	// add fields if the table is empty
	$query = 'SELECT count(*) as fields FROM #__aicontactsafe_fields';
	$db->setQuery( $query );
	$count = $db->loadResult();
	if ($count == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_fields` (`id`, `name`, `field_label`, `label_parameters`, `field_label_message`, `label_message_parameters`, `label_after_field`, `field_type`, `field_parameters`, `field_values`, `ordering`, `field_required`, `field_in_message`, `date_added`, `last_update`, `published`, `checked_out`, `checked_out_time`) VALUES
											   (1, \'name\', \'Name\', \'\', \'Name\', \'\', 0, \'TX\', "class=\'inputbox\' style=\'width:250px;\'", \'\', 1, 1, 1, now(), now(), 1, 0, \'0000-00-00\'),
											   (2, \'email\', \'Email\', \'\', \'Email\', \'\', 0, \'TX\', "class=\'inputbox\' style=\'width:250px;\'", \'\', 2, 1, 1, now(), now(), 1, 0, \'0000-00-00\'),
											   (3, \'phone\', \'Phone\', \'\', \'Phone\', \'\', 0, \'TX\', "class=\'inputbox\' style=\'width:250px;\'", \'\', 3, 0, 1, now(), now(), 1, 0, \'0000-00-00\'),
											   (4, \'subject\', \'Subject\', \'\', \'Subject\', \'\', 0, \'TX\', "class=\'inputbox\' style=\'width:250px;\'", \'\', 4, 1, 1, now(), now(), 1, 0, \'0000-00-00\'),
											   (5, \'message\', \'Message\', \'\', \'Message\', \'\', 0, \'ED\', "cols=\'40\' rows=\'10\'", \'\', 5, 1, 1, now(), now(), 1, 0, \'0000-00-00\'),
											   (6, \'send_to_sender\', \'Send a copy of this message to yourself\', \'\', \'Send a copy of this message to yourself\', \'\', 1, \'CK\', "class=\'inputbox\'", \'\', 6, 0, 0, now(), now(), 1, 0, \'0000-00-00\');';
		$db->setQuery( $query );
		$db->query();
	}

	// add contact_info
	// contact information
	$key = 'contact_info';
	$value = '<img style="margin-left: 10px; float: right;" alt="articles" src="images/stories/articles.jpg" width="128" height="96" /><div style="width: 150px; float: left;">Algis Info SRL<br />Str. Hărmanului Nr.63<br />bl.1A sc.A ap.8<br />Brașov, România<br />500232<br /><a target="_blank" href="http://www.algis.ro/">www.algis.ro</a></div>';
	$query = 'SELECT id FROM #__aicontactsafe_contactinformations WHERE info_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_contactinformations` (`id`, `profile_id`, `info_key`, `info_label`, `info_value`) VALUES ( null, 1, \'' . $key . '\', \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// meta_description
	$key = 'meta_description';
	$value = '';
	$query = 'SELECT id FROM #__aicontactsafe_contactinformations WHERE info_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_contactinformations` (`id`, `profile_id`, `info_key`, `info_label`, `info_value`) VALUES ( null, 1, \'' . $key . '\', \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// meta_keywords
	$key = 'meta_keywords';
	$value = '';
	$query = 'SELECT id FROM #__aicontactsafe_contactinformations WHERE info_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_contactinformations` (`id`, `profile_id`, `info_key`, `info_label`, `info_value`) VALUES ( null, 1, \'' . $key . '\', \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}
	// thank_you_message
	$key = 'thank_you_message';
	$value = 'Email sent. Thank you for your message.';
	$query = 'SELECT id FROM #__aicontactsafe_contactinformations WHERE info_key = \'' . $key . '\'';
	$db->setQuery( $query );
	$id = $db->loadResult();
	if ($id == 0) {
		$query = 'INSERT INTO `#__aicontactsafe_contactinformations` (`id`, `profile_id`, `info_key`, `info_label`, `info_value`) VALUES ( null, 1, \'' . $key . '\', \'' . $key . '\', \'' . $value . '\')';
		$db->setQuery( $query );
		$db->query();
	}

	// import joomla clases to manage file system
	jimport('joomla.filesystem.file');

	// copy joomfish contentelements
	$contentelements = JPath::clean(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomfish'.DS.'contentelements');
	if (is_dir($contentelements)) {
		$src = JPath::clean(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_aicontactsafe'.DS.'includes'.DS.'joomfish'.DS.'aicontactsafe_contactinformations.xml');
		$dest = JPath::clean(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.'aicontactsafe_contactinformations.xml');
		JFile::copy($src, $dest);
		$src = JPath::clean(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_aicontactsafe'.DS.'includes'.DS.'joomfish'.DS.'aicontactsafe_fields.xml');
		$dest = JPath::clean(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.'aicontactsafe_fields.xml');
		JFile::copy($src, $dest);
	}

	// copy artio plugin
	$artio = JPath::clean(JPATH_ROOT.DS.'components'.DS.'com_sef'.DS.'sef_ext');
	if (is_dir($artio)) {
		$src = JPath::clean(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_aicontactsafe'.DS.'includes'.DS.'artio'.DS.'com_aicontactsafe.php');
		$dest = JPath::clean(JPATH_ROOT.DS.'components'.DS.'com_sef'.DS.'sef_ext'.DS.'com_aicontactsafe.php');
		JFile::copy($src, $dest);
		$src = JPath::clean(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_aicontactsafe'.DS.'includes'.DS.'artio'.DS.'com_aicontactsafe.xml');
		$dest = JPath::clean(JPATH_ROOT.DS.'components'.DS.'com_sef'.DS.'sef_ext'.DS.'com_aicontactsafe.xml');
		JFile::copy($src, $dest);
	}
?>
	<div class="header">Congratulations, aiContactSafe is now installed!</div>
	<br/>
	<br/>
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr>
			<td width="50%" valign="top">
				<img src="<?php echo JURI::root().'administrator/components/com_aicontactsafe/images/logo.gif' ;?>" border="0" /><br/>
				<br/>
				A contact form system developed by <a href="http://www.algis.ro/" target="_blank">Algis Info</a>, released under a <a href="http://www.gnu.org/licenses/gpl-2.0.html" target="_blank">GNU/GPL License</a>.<br/>
				<?php echo JText::_( 'Version' ); ?>&nbsp;<?php echo $_version; ?><br/>
				Programmer : Alexandru Dobrin &lt;alex@algis.ro&gt;<br/><br/>
				<br/>
			</td>
			<td width="50%" valign="top">
				<h3>Credits</h3><br/>
				<br/>
				<b>CAPTCHA system</b> : <br/>
				- developed by Jose Rodriguez &lt;jose.rodriguez@exec.cl&gt;<br/>
				- implemented in joomla by Alexandru Dobrin &lt;alex@algis.ro&gt;<br/>
				<br>
				You can download the original version here : <a href="http://code.google.com/p/cool-php-captcha" target="_blank">http://code.google.com/p/cool-php-captcha</a>.<br/>
				<br/>
				<b>Icons pack</b> : <br/>
				- made by Freeiconsdownload from <a href="http://www.freeiconsweb.com" target="_blank">www.freeiconsweb.com</a><br/>
				- adapted and implemented in aiContactSafe by Alexandru Dobrin &lt;alex@algis.ro&gt;<br/>
				<br/>
				<b>German translation</b> : <br/>- Pawel Koch <a href="http://www.le5.ch" target="_blank">www.le5.ch</a><br/>
				<br/>
				<b>German translation of instructions</b> : <br/>- Pawel Koch <a href="http://www.le5.ch" target="_blank">www.le5.ch</a><br/>
				<br/>
				<b>Greek translation</b> : <br/>- Themistoklis Georgiadis <a href="http://www.globalinfoweb.com" target="_blank">www.globalinfoweb.com</a><br/>
				<br/>
				<b>Greek translation of instructions</b> : <br/>- Themistoklis Georgiadis <a href="http://www.globalinfoweb.com" target="_blank">www.globalinfoweb.com</a><br/>
				<br/>
				<b>English translation</b> : <br/>- Nic Irvine <a href="http://www.swanshops.com" target="_blank">www.swanshops.com</a><br/>
				<br/>
				<b>English translation of instructions</b> : <br/>- Nic Irvine <a href="http://www.swanshops.com" target="_blank">www.swanshops.com</a><br/>
				<br/>
				<b>Spanish translation</b> : <br/>- Pablo Soto <a href="http://www.tecnoartestudio.com" target="_blank">www.tecnoartestudio.com</a><br/>
				<br/>
				<b>Spanish translation of instructions</b> : <br/>- Pablo Soto <a href="http://www.tecnoartestudio.com" target="_blank">www.tecnoartestudio.com</a><br/>
				<br/>
				<b>French translation</b> : <br/>- Denis Gravel <a href="http://www.csmissionnaires.org" target="_blank">www.csmissionnaires.org</a><br/>
				<br/>
				<b>French translation of instructions</b> : <br/>- Denis Gravel <a href="http://www.csmissionnaires.org" target="_blank">www.csmissionnaires.org</a><br/>
				<br/>
				<b>Italian translation</b> : <br/>- Fabrizio Degni <a href="http://www.trioptimumcorporation.com" target="_blank">www.trioptimumcorporation.com</a><br/>
				<br/>
				<b>Polish translation</b> : <br/>- Krzysztof Machelski <a href="http://www.clearsoft.pl" target="_blank">www.clearsoft.pl</a><br/>
				<br/>
				<b>Serbian (Cyrillic) translation</b> : <br/>- krca437<br/>
				<br/>
				<br/>
			</td>
		</tr>
	</table>
<?php
}
?>
