<?php
/**
 * @version     $Id$ 2.0.1 0
 * @package     Joomla
 * @copyright   Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license     GNU/GPL, see LICENSE.php
 *
 * added/fixed in version 2.0.1
 * - added custom field date format
 * - added mark_required_fields character
 * - added always_send_to_defaut
 * - added Artio activation
 * - added Joom!Fish activation
 * - removed all the fields moved to profile
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

?>

<?php 
	// header of the adminForm
	// don't remove this line
	echo $this->getTmplHeader();
?>

<fieldset class="adminform">
	<legend><?php echo JText::_( 'Control Panel' ); ?></legend>
	<table id="control_panel">
		<?php
			if ( count($this->withoutMessageSection) > 0 ) {
		?>
		<tr>
			<td class="key">
				<h3 style="color:#FF0000"><?php echo JText::_( 'Warning' ); ?></h3>
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<table border="0" cellpadding="0" cellspacing="0" style="color:#FF0000">
				<?php
					foreach($this->withoutMessageSection as $template) {
				?>
					<tr><td style="color:#333333; font-weight:bold;"><?php echo $template; ?></td><td>&nbsp;&nbsp;</td><td><?php echo JText::_( 'this template doesn\'t have the section message activated' ); ?></td></tr>
				<?php
					}
				?>
					<tr><td colspan="3">&nbsp;</td></tr>
					<tr><td colspan="3"><?php echo JText::_( 'If a template doesn\'t have the section message activated you can\'t see the component feedback in front end.' ); ?></td></tr>
					<tr><td colspan="3"><?php echo JText::_( 'You need to add this text' ); ?>&nbsp;&lt;jdoc:include type="message" /&gt;&nbsp;<?php echo JText::_( 'somewhere above this text' ); ?>&nbsp;&lt;jdoc:include type="component" /&gt;&nbsp;<?php echo JText::_( 'in the index.php file of the template.' ); ?></td></tr>
					<tr><td colspan="3"><?php echo JText::_( 'For more information see this web page' ); ?> : <a href="http://docs.joomla.org/Jdoc_statements" target="_blank">http://docs.joomla.org/Jdoc_statements</a></td></tr>
				</table>
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<?php
			}
		?>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Use aiContactSafe css in backend' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="checkbox" type="checkbox" name="use_css_backend" id="use_css_backend" value="1" <?php echo ($this->use_css_backend)?'checked':'' ?> />
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Activate help' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="checkbox" type="checkbox" name="activate_help" id="activate_help" value="1" <?php echo ($this->activate_help)?'checked':'' ?> />
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Date format' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="textbox" type="text" name="date_format" id="date_format" value="<?php echo $this->date_format; ?>"  />
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Activate spam control' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="checkbox" type="checkbox" name="activate_spam_control" id="activate_spam_control" value="1" <?php echo ($this->activate_spam_control)?'checked':'' ?> />
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Block messages with' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<textarea class="inputbox" name="block_words" id="block_words" rows="6" cols="50"><?php echo $this->block_words; ?></textarea>
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Record blocked messages' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="checkbox" type="checkbox" name="record_blocked_messages" id="record_blocked_messages" value="1" <?php echo ($this->record_blocked_messages)?'checked':'' ?> />
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Activate IP ban' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="checkbox" type="checkbox" name="activate_ip_ban" id="activate_ip_ban" value="1" <?php echo ($this->activate_ip_ban)?'checked':'' ?> />
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'IPs to ban' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<textarea class="inputbox" name="ban_ips" id="ban_ips" rows="6" cols="50"><?php echo $this->ban_ips; ?></textarea>
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Redirect banned IPs to' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="textbox" type="text" name="redirect_ips" id="redirect_ips" value="<?php echo $this->redirect_ips; ?>"  />
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Upload attachments folder' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<?php echo JPATH_ROOT.DS; ?><input class="textbox" type="text" name="upload_attachments" id="upload_attachments" value="<?php echo $this->upload_attachments; ?>"  />
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Maximum attachments size (in bytes)' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="textbox" type="text" name="maximum_size" id="maximum_size" value="<?php echo $this->maximum_size; ?>"  />
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Allowed attachments types' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="textbox" type="text" name="attachments_types" id="attachments_types" value="<?php echo $this->attachments_types; ?>"  />
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Attach to email' ); ?>:
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<input class="checkbox" type="checkbox" name="attach_to_email" id="attach_to_email" value="1" <?php echo ($this->attach_to_email)?'checked':'' ?> />
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Activate Artio' ); ?>
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<?php echo $this->activate_artio; ?>
			</td>
		</tr>
		<tr>
			<td class="key">
				<?php echo JText::_( 'Activate Joom!Fish' ); ?>
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<?php echo $this->activate_joomfish; ?>
			</td>
		</tr>
		<tr>
			<td colspan="3" class="space">&nbsp;</td>
		</tr>
		<tr>
			<td class="key">
				<font color="#FF0000"><?php echo JText::_( 'Delete database tables' ); ?></font>
			</td>
			<td class="space">&nbsp;</td>
			<td class="value">
				<button onclick="document.getElementById('task').value='confirm_delete_all';this.form.submit();"><?php echo JText::_( 'Go' ); ?></button>&nbsp;&nbsp;&nbsp;<font color="#FF0000"><?php echo JText::_( 'DO_NOT_USE' ); ?></font>
			</td>
		</tr>
	</table>
</fieldset>

<?php 
	// footer of the adminForm
	// don't remove this line
	echo $this->getTmplFooter();
?>
