<?php
/*
// "bretteleben.de CSS Gallery" Plugin for Joomla 1.5 - Version 1.1.2
// License: http://www.gnu.org/copyleft/gpl.html
// Author: Andreas Berger - http://www.bretteleben.de
// Copyright (c) 2009 Andreas Berger - andreas_berger@bretteleben.de
// Project page and Demo at http://www.bretteleben.de
// ***Last update: 2009-03-24***
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

// Import library dependencies
jimport('joomla.event.plugin');

class plgContentBecssg extends JPlugin
{
	//Constructor
	function plgContentBecssg( &$subject )
	{
		parent::__construct( $subject );
		// load plugin parameters
		$this->_plugin = JPluginHelper::getPlugin( 'content', 'becssg' );
		$this->_params = new JParameter( $this->_plugin->params );
	}

	function onPrepareContent(&$row, &$params, $limitstart) {

		// just startup
		global $mainframe;
		
		// root folder
		$rootfolder = '/images/stories/';
		//notice: if you want to use folders outside images/stories set $rootfolder = '/'; to start from joomla-root

		// checking
		if ( !preg_match("#{becssg}(.*?){/becssg}#s", $row->text) ) {
			return;
		}

		$plugin =& JPluginHelper::getPlugin('content', 'becssg');
		$pluginParams = new JParameter( $plugin->params );

		// j!1.5 paths
		$mosConfig_absolute_path = JPATH_SITE;
		$mosConfig_live_site = JURI :: base();
		if(substr($mosConfig_live_site, -1)=="/") $mosConfig_live_site = substr($mosConfig_live_site, 0, -1);

		// Parameters
		$_imwidth_ 		= $pluginParams->get('im_width', 400);
		$_imheight_ 	= $pluginParams->get('im_height', 300);
		$_imquality_ 	= $pluginParams->get('im_quality', 95);
		$_throw_ 			= $pluginParams->get('th_row', 4);
		$_tbquality_ 	= $pluginParams->get('th_quality', 80);
		$_im_preload_ = $pluginParams->get('im_preload', 1);
		$_im_align_ 	= $pluginParams->get('im_align', 1);
		$_im_fixstart_= $pluginParams->get('im_fixstart', 1);
		
		//calculate
		$thumbspace= 5;
		$thumbwidth=intval(($_imwidth_-($thumbspace*($_throw_-1)))/$_throw_);
		$thumbheight=intval($thumbwidth*($_imheight_/$_imwidth_));
		$_imwidth_=$thumbspace*($_throw_-1)+$thumbwidth*$_throw_;

		// GD2 Library Check
		if(function_exists("gd_info")) {
			$gdinfo = gd_info();
			$gdsupport = array();
			$version = intval(ereg_replace('[[:alpha:][:space:]()]+', '', $gdinfo['GD Version']));
			if($version!=2) $gdsupport[] = '<div class="message"><b>Error</b>: GD2 library is not enabled in your server!</div>';
			if (!$gdinfo['JPG Support']) $gdsupport[] = '<div class="message"><b>Error</b>: GD2 library does not support JPG!</div>';
			if (!$gdinfo['GIF Create Support']) $gdsupport[] = '<div class="message"><b>Error</b>: GD2 library does not support GIF!</div>';
			if (!$gdinfo['PNG Support']) $gdsupport[] = '<div class="message"><b>Error</b>: GD2 library does not support PNG!</div>';
			if(count($gdsupport)) {
				foreach ($gdsupport as $k=>$v) {echo $v;}
			}
		}

		if (preg_match_all("#{becssg}(.*?){/becssg}#s", $row->text, $matches, PREG_PATTERN_ORDER) > 0) {
			$document =& JFactory::getDocument();
			$csscount = -1;
			$_target=$_SERVER['REQUEST_URI'];
			
			foreach ($matches[0] as $match) {
				$csscount++;
				$_images_dir_ = preg_replace("/{.+?}/", "", $match);
				unset($images);
				$noimage = 0;
				// read directory
				if ($dh = opendir($mosConfig_absolute_path.$rootfolder.$_images_dir_)) {
					while (($f = readdir($dh)) !== false) {
						if((substr(strtolower($f),-3) == 'jpg') || (substr(strtolower($f),-3) == 'gif') || (substr(strtolower($f),-3) == 'png')) {
							$noimage++;
							$images[] = array('filename' => $f);
							array_multisort($images, SORT_ASC, SORT_REGULAR);
						}
					}
					closedir($dh);
				}
				if($noimage) {
					if($csscount<=0){
//						$document->addCustomTag('<link href="'.$mosConfig_live_site.'/plugins/content/plugin_becssg/becssg.css" rel="stylesheet" type="text/css" />' );
					}
					$html2 = "\n<div id='becssg_holder_".$row->id."_".$csscount."'>\n";
					$html2 .= "<div id='becssg_main_".$row->id."_".$csscount."'>\n";

					//preload-div
					if($_im_preload_){
						$html3 = "\n<div id='becssg_pre_".$row->id."_".$csscount."'>\n";
					}
					//css
					$thecss=array();
					$thetopcss=array();

					for($a = 0;$a<$noimage;$a++) {
						if($images[$a]['filename'] != '') {
							$baseimg=$mosConfig_absolute_path.$rootfolder.$_images_dir_."/".$images[$a]['filename'];
							$imagedata = getimagesize($baseimg);

							//calculate thumbnails size
							$new_tw = $thumbwidth;							
							$new_th = (int)($imagedata[1]*($new_tw/$imagedata[0]));
							if($new_th > $thumbheight) {
								$new_th = $thumbheight;
								$new_tw = (int)($imagedata[0]*($new_th/$imagedata[1]));
							}
							//calculate image size
							$new_iw = $_imwidth_;							
							$new_ih = (int)($imagedata[1]*($new_iw/$imagedata[0]));
							if($new_ih > $_imheight_) {
								$new_ih = $_imheight_;
								$new_iw = (int)($imagedata[0]*($new_ih/$imagedata[1]));
							}						
							
							//set thumb_name
							$thumbname=substr_replace($images[$a]['filename'], '', -4, 4);
							$thumbtype=strtolower(substr($images[$a]['filename'], -3, 3));
							$thumbname=$thumbname."_".$new_tw."_".$new_th."_".$_tbquality_.".".$thumbtype;
							$thumbdir=$mosConfig_absolute_path.$rootfolder.$_images_dir_."/thumbs/";
							$thumbabs=$thumbdir.$thumbname;
							//set img_name
							$imgname=substr_replace($images[$a]['filename'], '', -4, 4);
							$imgtype=$thumbtype;
							$imgname=$imgname."_".$new_iw."_".$new_ih."_".$_imquality_.".".$imgtype;
							$imgdir=$mosConfig_absolute_path.$rootfolder.$_images_dir_."/images/";
							$imgabs=$imgdir.$imgname;
							
							//use joomla ftp-layer
							jimport('joomla.filesystem.file');
							jimport('joomla.filesystem.folder');
							//check_existence_of/create thumbdirectory
							if(!JFolder::create($thumbdir)) {
								echo "Failed creating thumbnail directory ".$thumbdir;
							}
							JFile::write($thumbdir."index.html", "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");

							//check_existence_of/create imagedirectory
							if(!JFolder::create($imgdir)) {
								echo "Failed creating thumbnail directory ".$imgdir;
							}
							JFile::write($imgdir."index.html", "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");

							//check_existence_of/create thumb
							if(!is_file($thumbabs)){
								if($thumbtype=="jpg"){
									$image = imagecreatefromjpeg($baseimg);
									$image_dest = imagecreatetruecolor($new_tw, $new_th);
									imagecopyresampled($image_dest, $image, 0, 0, 0, 0, $new_tw, $new_th, $imagedata[0], $imagedata[1]);
									ob_start(); // start a new output buffer
								  imagejpeg($image_dest, '', $_tbquality_);
									$buffer = ob_get_contents();
									ob_end_clean(); // stop this output buffer
								}
								elseif($thumbtype=="gif"){
									$image = ImageCreateFromGif($baseimg);
									$image_dest = ImageCreate($new_tw, $new_th);
									ImagePaletteCopy($image_dest,$image);
									ImageCopyResized($image_dest,$image,0,0,0,0,$new_tw,$new_th,$imagedata[0],$imagedata[1]);
									ob_start(); // start a new output buffer
									Imagegif($image_dest, '', $_tbquality_);
									$buffer = ob_get_contents();
									ob_end_clean(); // stop this output buffer
								}
								elseif($thumbtype=="png"){
									$image = ImageCreateFromPng($baseimg);
									$image_dest = imagecreatetruecolor($new_tw, $new_th);
									ImagePaletteCopy($image_dest,$image);
									ImageCopyResized($image_dest, $image, 0, 0, 0, 0, $new_tw, $new_th, $imagedata[0], $imagedata[1]);
									if(substr(phpversion(), 0, 1)>=5){$_pngquality_=intval(($_tbquality_-10)/10);}
									ob_start(); // start a new output buffer
									Imagepng($image_dest,'',$_pngquality_);
									$buffer = ob_get_contents();
									ob_end_clean(); // stop this output buffer
								}
								JFile::write($thumbabs, $buffer);
								imagedestroy($image_dest);
							}

							//check_existence_of/create image
							if(!is_file($imgabs)){
								if($imgtype=="jpg"){
									$image = imagecreatefromjpeg($baseimg);
									$image_dest = imagecreatetruecolor($new_iw, $new_ih);
									imagecopyresampled($image_dest, $image, 0, 0, 0, 0, $new_iw, $new_ih, $imagedata[0], $imagedata[1]);
									ob_start(); // start a new output buffer
								  imagejpeg($image_dest, '', $_imquality_);
									$buffer = ob_get_contents();
									ob_end_clean(); // stop this output buffer
								}
								elseif($imgtype=="gif"){
									$image = ImageCreateFromGif($baseimg);
									$image_dest = ImageCreate($new_iw, $new_ih);
									ImagePaletteCopy($image_dest,$image);
									ImageCopyResized($image_dest,$image,0,0,0,0,$new_iw,$new_ih,$imagedata[0],$imagedata[1]);
									ob_start(); // start a new output buffer
									Imagegif($image_dest, '', $_imquality_);
									$buffer = ob_get_contents();
									ob_end_clean(); // stop this output buffer
								}
								elseif($imgtype=="png"){
									$image = ImageCreateFromPng($baseimg);
									$image_dest = imagecreatetruecolor($new_iw, $new_ih);
									ImageCopyResized($image_dest, $image, 0, 0, 0, 0, $new_iw, $new_ih, $imagedata[0], $imagedata[1]);
									if(substr(phpversion(), 0, 1)>=5){$_pngquality_=intval(($_imquality_-10)/10);}
									ob_start(); // start a new output buffer
									Imagepng($image_dest,'',$_pngquality_);
									$buffer = ob_get_contents();
									ob_end_clean(); // stop this output buffer
								}
								JFile::write($imgabs, $buffer);
								imagedestroy($image_dest);
							}
							
							//link thumb
							$html2 .= "<img src='".$mosConfig_live_site.$rootfolder.$_images_dir_."/thumbs/".$thumbname."' alt='".substr($images[$a]['filename'], 0, -4)."' class='i_".$row->id."_".$csscount."_".$a."'/><a href='#' class='l_".$row->id."_".$csscount."_".$a." mylink_".$row->id."_".$csscount."' title='".substr($images[$a]['filename'], 0, -4)."'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</a>\n";
							//link preload-img
							if($_im_preload_){
								$html3 .="<img src='".$mosConfig_live_site.$rootfolder.$_images_dir_."/images/".$imgname."' alt='".substr($images[$a]['filename'], 0, -4)."' />\n";
							}
						
							//fed css-array
							$thumbrow=intval(($a)/$_throw_);
							$thumbrowpos=$a%$_throw_;
							$thumbleft=intval(($thumbwidth+$thumbspace)*$thumbrowpos+($thumbwidth-$new_tw)/2);
							$thumbtop=intval($_imheight_+($thumbspace+$thumbheight)*($thumbrow+1)-$new_th);
							$backgroundleft=intval(($_imwidth_-$new_iw)/2);
							$backgroundtop=intval(($_imheight_-$new_ih)/2);
							$thecss[]=".i_".$row->id."_".$csscount."_".$a." {position:absolute;left:".$thumbleft."px;top:".$thumbtop."px;width:".$new_tw."px;height:".$new_th."px;}";
							$thecss[]=".l_".$row->id."_".$csscount."_".$a." {position:absolute;left:".$thumbleft."px;top:".$thumbtop."px;width:".$new_tw."px;height:".$new_th."px;font-size:".$new_th."px;line-height:".$new_th."px;}";
							$thecss[]=".l_".$row->id."_".$csscount."_".$a.":hover {background-image:url(".$mosConfig_live_site.$rootfolder.$_images_dir_."/images/".$imgname.");background-position:".$backgroundleft."px ".$backgroundtop."px;}";
							//css for top image
							if($a==0) {
								$thetopcss[]=$imgname;
								$thetopcss[]=$backgroundleft;
								$thetopcss[]=$backgroundtop;
							}
						}
					}
					//calc gallerheight
					$galleryheight=intval($_imheight_+($thumbrow+1)*($thumbspace+$thumbheight));
					$html2 .="</div>\n</div>\n";
					//preload
					if($_im_preload_){
						$html3 .="</div>\n";
						$html2 .=$html3;
					}
				}
				$csstoinsert="<style type='text/css'>\n";
				$csstoinsert.="#becssg_holder_".$row->id."_".$csscount." {width:".$_imwidth_."px;height:".$galleryheight."px;}\n";
				if($_im_align_==0){$csstoinsert.="#becssg_holder_".$row->id."_".$csscount." {margin:0 0 0 auto;padding:0;display:block;width:".$_imwidth_."px;}\n";}
				elseif($_im_align_==1){$csstoinsert.="#becssg_holder_".$row->id."_".$csscount." {margin:auto;padding:0;display:block;width:".$_imwidth_."px;}\n";}
				$csstoinsert.="#becssg_main_".$row->id."_".$csscount." {display:block;position:absolute;width:".$_imwidth_."px;height:".$galleryheight."px;background-image:url(".$mosConfig_live_site.$rootfolder.$_images_dir_."/images/".$thetopcss[0].");background-position:".$thetopcss[1]."px ".$thetopcss[2]."px;background-repeat:no-repeat;}\n";
				if(!$_im_fixstart_){
				$csstoinsert.="#becssg_main_".$row->id."_".$csscount.":hover {background-image:url('');}\n";
				}
				$csstoinsert.=".mylink_".$row->id."_".$csscount." {text-decoration:none;overflow:hidden;z-index:5;}\n";
				$csstoinsert.=".mylink_".$row->id."_".$csscount.":hover {text-decoration:none;position:absolute;left:0;top:0;width:".$_imwidth_."px;height:".$galleryheight."px;background-repeat:no-repeat;z-index:2;}\n";
				//preload-css
				if($_im_preload_){
					$csstoinsert.="#becssg_pre_".$row->id."_".$csscount." {position:absolute;top:-100px;left:-100px;width:5px;height:5px;overflow:hidden;}\n";
					$csstoinsert.="#becssg_pre_".$row->id."_".$csscount." img {position:absolute;top:0;left:0;}\n";
				}
				$csstoinsert.="\n";
				for($i=0;$i<=count($thecss)-1;$i++){
					$csstoinsert.=trim($thecss[$i])."\n";
				}
				$csstoinsert.="</style>\n";
				$document->addCustomTag($csstoinsert);
				$_images_dir_ = preg_quote($_images_dir_, '#');
				$row->text = preg_replace( "#{becssg}".$_images_dir_."{/becssg}#s", $html2 , $row->text );
			}
		}
	}
}
?>